// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
var app = angular.module('starter', ['ionic','ionic.service.core', 'starter.controllers', 'ionic.rating', 'ngOpenFB', 'ionic.service.analytics'])

.run(function($ionicPlatform, ngFB, $ionicAnalytics) {
	
	//$ionicAnalytics.register();
	ngFB.init({appId: '203624399986960', tokenStore: window.localStorage});

	
  $ionicPlatform.ready(function() {
	//var push = new Ionic.Push({
	//});

	//push.register(function(token) {
	//	console.log("Device token:",token.token);
	//});
	  
	  
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })
  .state('home', {
	  url: '/home/',
	  templateUrl: 'templates/home.html',
	  controller: 'HomeController'
  })
  .state('selectlogin', {
      url: '/selectlogin/',
      //views: {
     //   'menuContent': {
          templateUrl: 'templates/selectlogin.html',
          controller: 'SelectLoginController'
      //  }
      
    })
	
	.state('createaccount', {
      url: '/createaccount/',
      views: {
        'menuContent': {
          templateUrl: 'templates/createaccount.html',
          controller: 'CreateAccountController'
        }
      }
    })
	.state('login', {
      url: '/login/',
      //views: {
       // 'menuContent': {
          templateUrl: 'templates/login.html',
          controller: 'LoginController'
       // }
      //}
    })
	.state('selectregion', {
      url: '/selectregion/',
      //views: {
     //   'menuContent': {
          templateUrl: 'templates/selectregion.html',
          controller: 'SelectRegionController'
       // }
     // }
    })

    .state('app.couponlist', {
      url: '/couponlist/:category',
      views: {
        'menuContent': {
          templateUrl: 'templates/couponlist.html',
          controller: 'CouponListController'
        }
      }
    })

  .state('app.couponview', {
    url: '/couponview/:couponid',
    views: {
      'menuContent': {
        templateUrl: 'templates/couponview.html',
        controller: 'CouponViewController'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/couponlist/');
});
