app.controller('CouponViewController', ['$scope', '$stateParams', 'CouponService', '$interval', '$ionicPopup', function($scope, $stateParams, CouponService, $interval, $ionicPopup) {
	var couponId = $stateParams.couponid;
	
	//$scope.couponService = CouponService;
	
	//Get the coupondata from the downloaded list of coupons
	$scope.couponData = CouponService.getCouponById(couponId);
	
	
	//Register use of coupon with the server
	$scope.useCoupon = function()
	{
		
		 
		   var alertPopup = $ionicPopup.alert({
			 title: 'Gebruik Korting',
			 template: "Als je deze korting wilt verzilveren, druk dan op de 'Akkoord' knop wanneer je bij de kassa geholpen wordt."
		   })
		   .then( function()
		   {
			  CouponService.couponCallback($scope.couponData.id)
				.success(function(data){
					//Coupon used
				})
				.error(function(err)
				{
					//error while registering use on server
				}); 
		   });
		
	};
	
	//Opens website in a new browser instance
	$scope.openWebsite = function()
	{
		if($scope.couponData.companywebsite.indexOf("http") == -1)
		{
			$scope.couponData.companywebsite = "http://" + $scope.couponData.companywebsite;
		}
		window.open($scope.couponData.companywebsite, '_system');
	};

	//Opens a google map of the company adres
	$scope.openLocationSite = function()
	{
		window.open("https://www.google.nl/maps/place/"+$scope.couponData.companyadres, '_system');
	};
	
	
	//Called every second to update the time related data of the current coupon
	$scope.updateTimer = function(){
		$scope.couponData.timeleftArray = CouponService.getTimeLeftArray($scope.couponData.expiretimestamp);
		$scope.couponData.daysLeft = $scope.couponData.timeleftArray[0];
		$scope.couponData.hoursLeft = $scope.couponData.timeleftArray[1];
		$scope.couponData.minLeft = $scope.couponData.timeleftArray[2];
		$scope.couponData.secLeft = $scope.couponData.timeleftArray[3];

		if($scope.couponData.daysLeft <= 0 && $scope.couponData.hoursLeft <= 0 && $scope.couponData.minLeft <= 0 && $scope.couponData.secLeft <= 0)
		{
		  $scope.couponData.validText = "<div class='status'>Deze actie is afgelopen</div>";
		}
		else
		{
		if($scope.couponData.minLeft < 10) $scope.couponData.minLeft = "0"+$scope.couponData.minLeft;
		if($scope.couponData.secLeft < 10) $scope.couponData.secLeft = "0"+$scope.couponData.secLeft;
		$scope.couponData.validText = "<div class='status'>Actie is nog geldig</div><div class='daysleft'>"+$scope.couponData.daysLeft + " Dagen</div> <div class='timeleft'>"+$scope.couponData.hoursLeft + ":"+$scope.couponData.minLeft + ":"+$scope.couponData.secLeft + "</div>";
	   }
	};
	
	//Init the time related data
	$scope.updateTimer();
	
	//Start updating the time related data every second
	$scope.timerInterval = $interval($scope.updateTimer, 1000);
	
	//Cancel the timer when leaving view
	$scope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams)
	{            
		$interval.cancel($scope.timerInterval);
    });
	
}]);