app.controller('LoginController', ['$scope', '$rootScope', '$stateParams', 'LocalStorage', '$ionicHistory', 'ngFB', 'AccountService', '$state', function($scope, $rootScope, $stateParams, LocalStorage, $ionicHistory, ngFB, AccountService, $state) {
	$scope.loginform = {};
	
	$scope.doFacebooklogin = function()
	{
		ngFB.login({scope: 'email,user_birthday'}).then(
        function (response) {
            if (response.status === 'connected') {
                console.log('Facebook login succeeded');
                $scope.fblogincallback(response);
            } else {
                alert('Facebook login failed');
            }
        });
	}
	
	$scope.fblogincallback = function(data)
	{
		console.log(data);
		if(data.status == "connected")
		{
			//Get the facebook user data
			ngFB.api({path: '/me?fields=id,first_name,last_name,email,gender,birthday'}).then(
				function(user)
				{
					var hashpw = AccountService.sha1(""+user.id+user.email);
					AccountService.checkLogin(user.id, hashpw).then(function (response)
					{
						if(LocalStorage.getVar("userdata") != undefined)
						{
							console.log("logged in via facebook account");
							console.log(response.data);
			
							$state.go("app.couponlist");
						}
						else
						{
							console.log("log in via facebook account failed" + response.data);
							$scope.formerror = true;
							$scope.errormessage = "Oeps! Inloggen met facebook niet gelukt.";
			
						}
					});
				}
			);
		}
	}
	
	$scope.doLogin = function()
	{
		var hashpass = AccountService.sha1($scope.loginform.pass);
		var user = $scope.loginform.user;
		
		AccountService.checkLogin(user, hashpass).then(function (response)
		{
			if(LocalStorage.getVar("userdata") != undefined)
			{
				console.log("logged in via bespaarin account");
				console.log(response.data);
				$state.go("app.couponlist");
			}
			else
			{
				console.log("log in via bespaarin account failed" + response.data);
				$scope.formerror = true;
				$scope.errormessage = "Oeps! Inloggen bij bespaarin niet gelukt.";
			}
		});
	}
}]);