app.controller('SelectLoginController', ['$scope', '$rootScope', '$stateParams', 'LocalStorage', 'AccountService', 'ngFB', '$state', '$ionicHistory',  function($scope, $rootScope, $stateParams, LocalStorage, AccountService, ngFB, $state, $ionicHistory) {
	
	//var menuBar = angular.element(document.querySelector('#menu-bar').querySelector('ion-header-bar'));
	$scope.createform = {};
	$scope.formerror = false;
	$scope.errormessage = "";
	
	if(LocalStorage.getVar("userdata") != undefined)
	{
		$ionicHistory.nextViewOptions({
			historyRoot: true
		});
		$state.go("app.couponlist");
	}
	
	$scope.doBespaarinLogin = function()
	{
		$state.go("login")
	}
	
	$scope.doCreateAccount = function()
	{
		var hashpass = AccountService.sha1($scope.createform.pass);
		var user = $scope.createform.user;
		
		if(user == undefined){
			$scope.formerror = true;
			$scope.errormessage = "Oeps! je hebt een onjuist e-mail adres ingevuld.";
			return;
		}
		
		if($scope.createform.pass == ""){
			$scope.formerror = true;
			$scope.errormessage = "Oeps! je hebt geen wachtwoord ingevuld.";
			return;
		}
		//Do validation here
		//Email validation
		var x = user;
		var atpos = x.indexOf("@");
		var dotpos = x.lastIndexOf(".");
		if (atpos<1 || dotpos<atpos+2 || dotpos+2>=x.length) {
			$scope.formerror = true;
			return false;
		}
		//
		
		AccountService.createAccount(user, hashpass, user)
		.success(function (data)
		{
			if(data.result == "OK")
			{
				console.log("account created");
				AccountService.checkLogin(user, hashpass).then(function (response)
				{
					if(LocalStorage.getVar("userdata") != undefined)
					{
						console.log("logged in via bespaarin account");
						console.log(response.data);
						$state.go("selectregion");
					}
					else
					{
						console.log("log in via bespaarin account failed" + response.data);
						$scope.formerror = true;
						$scope.errormessage = "Oeps! Login gegevens onjuist.";
					}
				});
				
				
			}
			else
			{
				console.log("account failed: ");
				console.log(data);
				$scope.formerror = true;
				$scope.errormessage = "Oeps! Er bestaat al een account met dit e-mail adres.";
			}
		})
		.error(function (err)
		{
			//accountcreate network/server error
			$scope.formerror = true;
			$scope.errormessage = "Oeps! Er is iets mis met de verbinding.";
		});
	
	}
	
	$scope.doFacebooklogin = function()
	{
		ngFB.login({scope: 'email,user_birthday'}).then(
        function (response) {
            if (response.status === 'connected') {
                console.log('Facebook login succeeded');
                $scope.fblogincallback(response);
            } else {
                alert('Facebook login failed');
            }
        });
	}
	
	$scope.fblogincallback = function(data)
	{
		console.log(data);
		if(data.status == "connected")
		{
			//Get the facebook user data
			ngFB.api({path: '/me?fields=id,first_name,last_name,email,gender,birthday'}).then(
				function(user)
				{
					console.log(user);
					var hashpw = AccountService.sha1(""+user.id+user.email);
					AccountService.createAccount(user.id, hashpw, user.email, user.first_name, user.last_name, user.birthday, user.gender)
					.then(function(response){
						if(response.data.result == "OK")
						{
							//Account created
							console.log("account created");
							
	
							AccountService.checkLogin(user.id, hashpw).then(function (response)
							{
								if(LocalStorage.getVar("userdata") != undefined)
								{
									console.log("logged in via facebook account");
									console.log(response.data);
									//LocalStorage.setVar("isAuthenticated", true);
									//LocalStorage
									$state.go("selectregion");
								}
								else
								{
									console.log("log in via facebook account failed" + response.data);
								}
							});
						}
						else
						{
							console.log("account creation failed trying to log in anyway..");
							AccountService.checkLogin(user.id, hashpw).then(function (response)
							{
								if(LocalStorage.getVar("userdata") != undefined)
								{
									console.log("logged in via facebook account");
									console.log(response.data);
									//LocalStorage.setVar("isAuthenticated", true);
									//LocalStorage
									$state.go("selectregion");
								}
								else
								{
									console.log("log in via facebook account failed" + response.data);
								}
							});
							
						}
						
					});
					
					
				}
			);
		}
	}
	
	
	
	
	
}]);