app.directive('cachedImage', function() {
    return {
        restrict: 'E',
        scope: {
            class: '@',
            image: '@',
			imgtag: '@',
            transclude: '@',
        },
        link: function($scope, $element, $attr) {
            var inside = angular.element($element.children()[0]);

            $scope.$watch('image', function(newValue, oldValue) {
                if (newValue) {
                    if (ImgCache.ready) {
                        // Check if image is cached
                        ImgCache.isCached($scope.image, function(path, success) {
                            if (success) {
                                // Remove spinner
                                removeLoadingIndicator();
								if($scope.imgtag == 1)
								{
									inside.html("<img src='"+$scope.image+"' />")
								}
								else
								{
									inside.css('background-image', 'url("' + $scope.image + '")');
								}
                                //inside.html("<img src='"+$scope.image+"' />")

                                ImgCache.useCachedBackground(inside);
                            } else {
                                download();
                            }
                        });
                    } else {
                        download();
                    }
                }
            });

            function download() {
                // Add loading indicator
                if (!$scope.transclude)
                    inside.html('<i class="icon icon-md ion-ios7-reloading"></i>');

                if (ImgCache.ready) {
                    inside.css('background-image', 'url("' + $scope.image + '")');
                    //inside.html("<img src='"+$scope.image+"' />")
                    ImgCache.cacheBackground(inside, function() {
                        // Use cached image
                        removeLoadingIndicator();
                        ImgCache.useCachedBackground(inside);
                    }, function() {
                        console.error('Could not download image (ImgCache).');
                        removeLoadingIndicator();
                    });
                } else {
                    var img = new Image();
                    img.src = $scope.image;

                    img.onload = function() {
                        removeLoadingIndicator();
						if($scope.imgtag == 1)
								{
									inside.html("<img src='"+$scope.image+"' />")
								}
								else
								{
									inside.css('background-image', 'url("' + $scope.image + '")');
								}
                        //inside.css('background-image', 'url("' + $scope.image + '")');
                        //inside.html("<img src='"+$scope.image+"' />")
                    };

                    img.onerror = function() {
                        console.error('Could not download image.');
                        removeLoadingIndicator();
                    };
                }
            }

            function removeLoadingIndicator() {
                if (!$scope.transclude)
                    inside.html('');
            }
        },
        transclude: true,
        template: '<div class="cachedImage" ng-transclude></div>',
    };
});