app.factory('AccountService', ['$http', '$rootScope', 'LocalStorage', function($http, $rootScope, LocalStorage) {
	
	

	this.checkLogin = function(_user, _pass)
	{
		return $http.post("http://api.bespaarin.nl/api/accounts.php?action=login", "user="+ _user+ "&pass="+ _pass,{
              headers : {
                'Content-Type' : 'application/x-www-form-urlencoded'
            }

		})
		.success(function (data)
		{
			if(data.result == "OK")
			{
				//login success
				console.log("setting user data in localstorage");
				data.userdata.token = data.token; //Store the session token
				LocalStorage.setObject("userdata", data.userdata);
			}
			else
			{
				//login failed
				console.log("failed:"+data);
			}
		})
		.error(function (err)
		{
			//accountcreate network/server error
		});
	}
	
	this.logOff = function()
	{
		LocalStorage.unset("userdata");//unset the userdata
	}
	
	this.isLoggedIn = function()
	{
		return LocalStorage.getObject("userdata") != undefined;
	}
	
	this.createAccount = function(_user, _pass, _email, _name, _lastname, _birthdate, _gender)
	{
		return $http.post("http://api.bespaarin.nl/api/accounts.php?action=create",'user='+_user+ '&pass='+ _pass+ '&email='+ _email+ '&name=' + _name+ '&lastname=' + _lastname+ '&birthdate=' + _birthdate+ '&gender=' + _gender,{
              headers : {
                'Content-Type' : 'application/x-www-form-urlencoded'
            }

		})
		.success(function (data)
		{
			if(data.result == "OK")
			{
				//accountcreate success
			}
			else
			{
				//accountcreate failed
			}
		})
		.error(function (err)
		{
			//accountcreate network/server error
		});
	}
	
	this.updateRegionSettings = function()
	{
		var userdata = LocalStorage.getObject("userdata");
		if(userdata == undefined) return; //we are not logged in..
		
		var regionstr = "";
		if(LocalStorage.getObject("regionSettings").leeuwarden) regionstr +="leeuwarden,";
		if(LocalStorage.getObject("regionSettings").sneek) regionstr +="sneek,";
		
		return $http.post("http://api.bespaarin.nl/api/accounts.php?token="+userdata.token+"&action=setRegion",'user='+userdata.user+ '&regionstring='+ regionstr,{
              headers : {
                'Content-Type' : 'application/x-www-form-urlencoded'
            }

		});
		
	}
		
	this.sha1 = function(s)
	{
		var shaObj = new jsSHA("SHA-1", "TEXT");
		shaObj.update(String(s));
		var hash = shaObj.getHash("HEX");
		return hash;
	}
	
	return this;

}]);