app.factory('CouponService', ['$http', '$rootScope', function($http, $rootScope) { 	
	// Fill the coupon and company list. these can be used in the 'then()' function.
	// Use as CouponService.getAllCoupons().then(function(){});
	//
  	this.getAllCoupons = function(regionstring)
	{	
		return $http.get('http://api.bespaarin.nl/api/getcoupon.php?version=2&json=1&regionstring='+regionstring) 
		.success(function(data) { 
			
			// Sets the timeremaining text for each coupon and adds the company to the company list
			// This should be called after getAllCoupons with the data of getAllCoupons as argument.
			//for (var i = data.Coupons.length - 1; i >= 0; i--)
			for (var i = data.Coupons.length - 1; i >= 0; i--) 
			{
				var cCoup = data.Coupons[i];
				
				cCoup.timeleftArray = getTimeLeftArray(cCoup.expiretimestamp);
				cCoup.daysLeft = cCoup.timeleftArray[0];
				cCoup.hoursLeft = cCoup.timeleftArray[1];
				cCoup.minLeft = cCoup.timeleftArray[2];
				cCoup.secLeft = cCoup.timeleftArray[3];
				
				var daysremaining = Math.max(cCoup.daysLeft, 1);
				var daystext = "dagen";
				
				if(daysremaining == 1)
				  daystext = "dag"

				cCoup.listTimeString = daysremaining + " "+daystext+" resterend";
				if(cCoup.daysLeft <= 0 && cCoup.hoursLeft <= 0 && cCoup.minLeft <= 0 && cCoup.secLeft <= 0)
				{
					cCoup.listTimeString = "deze actie is verlopen";
				}


				if($rootScope.addedCompanies.indexOf(cCoup.company) < 0)
				{
					$rootScope.addedCompanies.push(cCoup.company);
					$rootScope.companies.push({name: cCoup.company});
				}
			}

			//TODO: REMOVE DEBUG SLICE CALL !!!!!
			$rootScope.couponList = data.Coupons;
			
		}) 
		.error(function(err) { 
		  return err; 
		});
	};
	
	
	// Get a coupon by id
	// getAllCoupons should be called first
	//
	this.getCouponById = function(id) 
	{
		for (var i = $rootScope.couponList.length - 1; i >= 0; i--) 
		{
			if($rootScope.couponList[i].id == id) return $rootScope.couponList[i];
		}
	};
	
	
	// Send a callback to the server that this coupon has been used
	// Use as CouponService.getAllCoupons().then(function(){}); 
	//
	this.couponCallback = function(couponid)
	{
		return $http.get("http://api.bespaarin.nl/api/couponcallback.php?cid="+couponid+"&confirmcode=0")
		.success(function(data) {
			//Coupon verzilvert
		})
		.error(function(err) {
			//Er is iets mis gegaan met het verzilveren.
		});
	};
		
	//
	//Helper methods
	//
	
	//
	//Get days/hours/min/secs left from a timestamp to now
	//
	function getTimeLeftArray(timestamp)
	{
		var d = new Date();
		var n = d.getTime();

		var diffInSeconds = timestamp - (n / 1000);
		var diff = new Array();

		/* sec */diff[3] = (diffInSeconds >= 60 ? diffInSeconds % 60 : diffInSeconds);
		/* min */diff[2] = (diffInSeconds = (diffInSeconds / 60)) >= 60 ? diffInSeconds % 60 : diffInSeconds;
		/* hours */diff[1] = (diffInSeconds = (diffInSeconds / 60)) >= 24 ? diffInSeconds % 24 : diffInSeconds;
		/* days */diff[0] = (diffInSeconds = (diffInSeconds / 24));

		diff[3] = Math.floor(diff[3]);
		diff[2] = Math.floor(diff[2]);
		diff[1] = Math.floor(diff[1]);
		diff[0] = Math.floor(diff[0]);



		return diff;
	};
	
	this.getTimeLeftArray = getTimeLeftArray;
	
	return this;
}]);