app.factory('LocalStorage', ['$window', function($window) { 	
	this.setVar = function(key, value) {
      $window.localStorage[key] = value;
    }
	
	this.getVar = function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    }
	
    this.setObject = function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    }
	
    this.getObject = function(key) {
	  if(!$window.localStorage.hasOwnProperty(key)) return undefined;
      return JSON.parse($window.localStorage[key] || '{}');
    }
	
	this.unset = function(key){
		delete $window.localStorage[key];
	}
	
	return this;
}]);